﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;

namespace Kolory_WPF.ModelWidoku
{ }

namespace Kolory_WPF
{
    public class ColorToBrushConverter : IValueConverter
    {
        private SolidColorBrush brush = new SolidColorBrush();

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            /*
            Color kolor = (Color)value;
            return new SolidColorBrush(kolor);
            */

            Color kolor = (Color)value;
            brush.Color = kolor;
            return brush;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            SolidColorBrush brush = (SolidColorBrush)value;
            return brush.Color;
        }
    }

    public class RGBToBrushConverter : IMultiValueConverter
    {
        private SolidColorBrush brush = new SolidColorBrush();

        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            byte r = (byte)values[0];
            byte g = (byte)values[1];
            byte b = (byte)values[2];
            brush.Color = Color.FromRgb(r, g, b);
            return brush;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            SolidColorBrush _brush = (SolidColorBrush)value;
            return new object[3] { _brush.Color.R, _brush.Color.G, _brush.Color.B };
        }
    }

    public class DoubleRGBToBrushConverter : IMultiValueConverter
    {
        private SolidColorBrush brush = new SolidColorBrush();

        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            byte r = (byte)(double)values[0];
            byte g = (byte)(double)values[1];
            byte b = (byte)(double)values[2];
            brush.Color = Color.FromRgb(r, g, b);
            return brush;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            SolidColorBrush _brush = (SolidColorBrush)value;
            return new object[3] { (double)_brush.Color.R, (double)_brush.Color.G, (double)_brush.Color.B };
        }
    }
}
